<?php

App::uses('PluginInstallShell', 'shells');
App::uses('File', 'Utility');

class EvShopInstallShell extends PluginInstallShell {

	public $uses = array(
		'EvTemplates.Template',
		'EvCore.Page',
		'EvCheckout.OrderStatus'
	);

	/**
	 * call parent run() This will auto run any migrations
	 *
	 * Use the run() method here to insert any content
	 */
	public function run() {
		parent::run();

		$date = date('Y-m-d H:i:s');

		// add all the base temoplates
		$this->Template->saveMany(
			array(
				array(
					'Template' => array(
						'name' => 'Checkout Successful',
						'template' => 'EvCheckout./Templates/Checkout/successful',
						'helperFunction' => 'N/A',
						'cfDataLabel' => 'Custom Data',
						'model' => 'Page',
						'is_active' => 1,
						'created' => $date,
						'modified' => $date
					)
				),
				array(
					'Template' => array(
						'name' => 'Checkout Failed',
						'template' => 'EvCheckout./Templates/Checkout/fail',
						'helperFunction' => 'N/A',
						'cfDataLabel' => 'Custom Data',
						'model' => 'Page',
						'is_active' => 1,
						'created' => $date,
						'modified' => $date
					)
				)
			)
		);
		$templateIds = $this->Template->find('list', array('callbacks' => false, 'limit' => 2, 'order' => 'Template.id DESC'));
		$templateIds = array_flip($templateIds);

		// add the pages for the index
		$this->Page->saveMany(
			array(
				array(
					'Page' => array(
						'title' => 'Order Successful',
						'is_active' => 1,
						'is_protected' => 1,
						'template_id' => $templateIds['Checkout Successful'],
						'created' => $date,
						'modified' => $date
					)
				),
				array(
					'Page' => array(
						'title' => 'Order Failed',
						'is_active' => 1,
						'is_protected' => 1,
						'template_id' => $templateIds['Checkout Failed'],
						'created' => $date,
						'modified' => $date
					)
				)
			)
		);
		$pageIds = $this->Page->find('list', array('callbacks' => false, 'limit' => 2, 'order' => 'Page.id DESC'));
		$pageIds = array_flip($pageIds);

		// write to the plugin config
		$configContents = '<?php

$config = array(
	\'EvCheckout\' => array(
		/**
		 * pageIds for success / fail pages
		 */
		\'pageIds\' => array(
			\'success\' => ' . $pageIds['Order Successful'] . ',
			\'fail\' => ' . $pageIds['Order Failed'] . '
		)
	)
);';

		$File = new File(APP . 'Config/Plugin/ev_checkout.php', true);
		$File->write($configContents);

		$this->OderStatus->saveMany(
			array(
				array(
					'OderStatus' => array(
						'name' => 'Awaiting Payment',
						'sequence' => 10,
						'is_active' => 1,
						'created' => $date,
						'modified' => $date
					)
				),
				array(
					'OderStatus' => array(
						'name' => 'Paid',
						'sequence' => 20,
						'is_active' => 1,
						'created' => $date,
						'modified' => $date
					)
				),
				array(
					'OderStatus' => array(
						'name' => 'Shipped',
						'sequence' => 30,
						'is_active' => 1,
						'created' => $date,
						'modified' => $date
					)
				)
			)
		);
	}
}
